#============================================================================================================
#
#	Ǘ[Uf[^ǗW[(HELM)
#	helm.pl
#	------------------------------------------
#	2003.02.13 start
#------------------------------------------------------------------------------------------------------------
#
#	Load																			; ǂݍ
#	Save																			; 񏑂
#	Set																				; [Uǉ
#	Change																			; [UݒύX
#	Delete																			; [U폜
#	CreateGroup																		; O[vǉ
#	ChangeGroupAuthor																; O[vύX
#	DeleteGroup																		; O[v폜
#	HasAuthority																	; mF
#	UserNum																			; [U擾
#	IsUser																			; [UpX`FbN
#
#============================================================================================================
package	HELM;

#------------------------------------------------------------------------------------------------------------
#
#	RXgN^ - new
#	-------------------------------------------
#	@FȂ
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub new
{
	my		$this = shift;
	my		(%GROUP,%USER,$KIND,$NUM,$obj);
	
	undef(%GROUP);																	# NA
	undef(%USER);
	
	InitGroupInfo(\%GROUP);															# 
	
	$obj = {
		'GROUPS'	=> \%GROUP,														# O[v
		'USERS'		=> \%USER,														# [U
		'NUM'		=> $NUM,														# o^[U
		'KIND'		=> $KIND,														# tO
		'USER'		=> undef														# Jg[U
	};
	bless $obj,$this;
	
	return $obj;
}

#------------------------------------------------------------------------------------------------------------
#
#	IuWFNg擾 - Object
#	-------------------------------------------
#	@F$obj : 擾IuWFNg
#	߂lFIuWFNg̎Q
#
#------------------------------------------------------------------------------------------------------------
sub Object
{
	my		$this = shift;
	my		($obj) = @_;
	
	return $this->{$obj};
}

#------------------------------------------------------------------------------------------------------------
#
#	[Uǂݍ - Load
#	-------------------------------------------
#	@F$M : MELKOR
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub Load
{
	my		$this = shift;
	my		($M) = @_;
	my		(@group,@user,$gname,$uname,$rname);
	my		($pass,$rng,$rt,$path,$disc);
	
	$path = '.' . $M->Get('INFO');
	
	open(GRP,"<$path/group.cgi");													# O[vǂݍ
	@group = <GRP>;
	close(GRP);
	open(USER,"<$path/users.cgi");													# [Uǂݍ
	@user = <USER>;
	close(USER);
	
	foreach	(@group){																# O[vo^
		chomp($_);
		($gname,$rng,$disc,$rt)		= split(/<>/,$_);
		$this->{'GROUPS'}->{$gname}	= "$rng<>$disc<>$rt";
	}
	InitGroupInfo($this->{'GROUP'});												# ō
	
	foreach	(@user){																# [Uo^
		chomp($_);
		($uname,$pass,$gname,$rname)	= split(/<>/,$_);
		$this->{'USERS'}->{$uname}		= "$pass<>$gname<>$rname";					# ݒ
	}
	$this->{'NUM'}	= @user;
	$this->{'KIND'}	= 1;
}

#------------------------------------------------------------------------------------------------------------
#
#	[U񏑂 - Save
#	-------------------------------------------
#	@F$M : MELKOR
#			$f : tO
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub Save
{
	my		$this = shift;
	my		($M,$f) = @_;
	my		($pOBJ,$path);
	
	$path = '.' . $M->Get('INFO');
	
	if	($f & 1){																	# O[vۑ
		$pOBJ = $this->{'GROUPS'};
		eval{	chmod(0666,"$path/group.cgi");	};									# p[~bVݒ
		open(GRP,">$path/group.cgi");
		eval{	flock(GRP,2);	};
		foreach	(sort keys %$pOBJ){
			print GRP "$_<>$$pOBJ{$_}\n";
		}
		close(GRP);
		eval{	chmod($M->Get('PM-ADM'),"$path/group.cgi");	};						# p[~bVݒ
	}
	if	($f & 2){																	# [Uۑ
		$pOBJ = $this->{'USERS'};
		eval{	chmod(0666,"$path/users.cgi");	};									# p[~bVݒ
		open(USER,">$path/users.cgi");
		eval{	flock(USER,2);	};
		foreach	(sort keys %$pOBJ){
			print USER "$_<>$$pOBJ{$_}\n";
		}
		close(USER);
		eval{	chmod($M->Get('PM-ADM'),"$path/users.cgi");	};						# p[~bVݒ
	}
}

#------------------------------------------------------------------------------------------------------------
#
#	Ǘ[Uǉ - Set
#	-------------------------------------------
#	@F$name  : [U
#			$pass  : pX[h
#			$group : O[v
#			$rname : tl[
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub Set
{
	my		$this = shift;
	my		($name,$pass,$group,$rname) = @_;
	
	if	($this->{'KIND'}){
		$this->{'USERS'}->{$name}	= "$pass<>$group<>$rname";
		$this->{'NUM'}++;
	}
}

#------------------------------------------------------------------------------------------------------------
#
#	Ǘ[Uǉ - Change
#	-------------------------------------------
#	@F$name  : [U
#			$pass  : pX[h
#			$group : O[v
#			$rname : tl[
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub Change
{
	my		$this = shift;
	my		($name,$pass,$group,$rname) = @_;
	
	if	($this->{'KIND'}){
		$this->{'USERS'}->{$name}	= "$pass<>$group<>$rname";
	}
}

#------------------------------------------------------------------------------------------------------------
#
#	[U폜 - Delete
#	-------------------------------------------
#	@F$user : [U
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub Delete
{
	my		$this = shift;
	my		($user) = @_;
	
	delete($this->{'USERS'}->{$user});
}

#------------------------------------------------------------------------------------------------------------
#
#	VO[vǉ - CreateGroup
#	-------------------------------------------
#	@F$name  : O[v
#			@right : Xg
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub CreateGroup
{
	my		$this = shift;
	my		($group,$range,$disc,@alist) = @_;
	my		(@al,$cnt,$work);
	
	if	($this->{'KIND'} && $this->{'GROUPS'}->{$group} eq ""){						# Ԑ
		if	($alist[0] eq '*'){														# S
			$work = '*';
		}
		else{																		# ȊO
			$work = join(",",@alist);												# 
		}
		$this->{'GROUPS'}->{$group} = "$range<>$disc<>$work";						# O[vݒ
	}
}

#------------------------------------------------------------------------------------------------------------
#
#	O[vύX - ChangeGroupAuthor
#	-------------------------------------------
#	@F$group : O[v
#			$range : K͈
#			$disc  : Rg
#			@alist : Xg
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub ChangeGroupAuthor
{
	my		$this = shift;
	my		($group,$range,$disc,@alist) = @_;
	my		($rg,$dc,$work,@al);
	
	if	($this->{'KIND'} && $this->{'GROUPS'}->{$group}){							# Ԑ
		($rg,$dc,$work) = split(/<>/,$this->{'GROUPS'}->{$group});
		if	($range){	$rg = $range;	}											# K͈
		if	($disc){	$dc = $disc;	}											# Rg
		
		if	($alist[0] eq '*'){														# S
			$work = '*';
		}
		else{																		# ȊO
			$work = join(",",@alist);												# 
		}
		$this->{'GROUPS'}->{$group} = "$rg<>$dc<>$work";							# O[vݒ
	}
}

#------------------------------------------------------------------------------------------------------------
#
#	O[v폜 - DeleteGroup
#	-------------------------------------------
#	@F$group : O[v
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub DeleteGroup
{
	my		$this = shift;
	my		($group) = @_;
	
	delete($this->{'GROUPS'}->{$group});
}

#------------------------------------------------------------------------------------------------------------
#
#	O[vXg擾 - GetGroupAuthorList
#	--------------------------------------------------
#	@F$group : O[v
#	߂lFXg
#
#------------------------------------------------------------------------------------------------------------
sub GetGroupAuthorList
{
	my		$this = shift;
	my		($group) = @_;
	my		(@ret,$rng,$disc,$auth,$i);
	
	($rng,$disc,$auth) = split(/<>/,$this->{'GROUPS'}->{$group});
	
	if	($auth eq '*'){
		for	($i = 1;$i < 79;$i++){
			push(@ret,$i);
		}
	}
	else{
		@ret = split(/\,/,$auth);
	}
	
	return @ret;
}

#------------------------------------------------------------------------------------------------------------
#
#	[U擾 - UserNum
#	-------------------------------------------
#	@FȂ
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub UserNum
{
	my		$this = shift;
	
	return $this->{'NUM'};
}

#------------------------------------------------------------------------------------------------------------
#
#	Jg[Uݒ - SetUser
#	-------------------------------------------
#	@F$name : [U
#	߂lF:1 s[U:0
#
#------------------------------------------------------------------------------------------------------------
sub SetUser
{
	my		$this = shift;
	my		($name) = @_;
	my		($obj,%AUTH,$pass,$group,$whole);
	my		($range,$disc,$work,@auth);
	
	if	(exists($this->{'USERS'}->{$name})){
		($pass,$group,$whole)	= split(/<>/,$this->{'USERS'}->{$name});
		($range,$disc,$work)	= split(/<>/,$this->{'GROUPS'}->{$group});
		@auth = split(/,/,$work);
		foreach	(@auth){
			$AUTH{$_} = 1;
		}
		$obj = {
			'PASS'		=> $pass,
			'RANGE'		=> $range,
			'GROUP'		=> $group,
			'NAME'		=> $whole,
			'AUTHOR'	=> \%AUTH
		};
		$this->{'USER'} = $obj;
		return 1;
	}
	return 0;
}

#------------------------------------------------------------------------------------------------------------
#
#	Jg[U擾 - GetUserInfo
#	-------------------------------------------
#	@F$key : L[
#	߂lF
#
#------------------------------------------------------------------------------------------------------------
sub GetUserInfo
{
	my		$this = shift;
	my		($key) = @_;
	
	if	($this->{'USER'}){
		return $this->{'USER'}->{$key};
	}
	return '';
}

#------------------------------------------------------------------------------------------------------------
#
#	[UmF - HasAuthority
#	-------------------------------------------
#	@F$right : x
#			$range : ͈
#	߂lFȂ1,ȂȂ0
#
#------------------------------------------------------------------------------------------------------------
sub HasAuthority
{
	my		$this = shift;
	my		($right,$range) = @_;
	my		($rng);
	
	if	($this->{'USER'}){
		$rng = $this->{'USER'}->{'RANGE'};
		if	($rng eq $range || $rng eq '*' || $range eq ''){
			if	($this->{'USER'}->{'AUTHOR'}->{'*'}){
				return 1;
			}
			if	($this->{'USER'}->{'AUTHOR'}->{$right}){
				return 1;
			}
		}
	}
	return 0;
}

#------------------------------------------------------------------------------------------------------------
#
#	[UpX`FbN - IsUser
#	-------------------------------------------
#	@F$pass : [UpX
#	߂lFOKȂ1ANGȂ0
#
#------------------------------------------------------------------------------------------------------------
sub IsUser
{
	my		$this = shift;
	my		($pass) = @_;
	
	if	($this->{'USER'}){
		if	($this->{'USER'}->{'PASS'} eq $pass){
			return 1;
		}
	}
	return 0;
}

#------------------------------------------------------------------------------------------------------------
#
#	O[v̏ - InitGroupInfo
#	-------------------------------------------
#	@F$pGRP : O[vnbV̎Q
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub InitGroupInfo
{
	my		($pGRP) = @_;
	my		($range,$disc,$alist);
	
	$range	= '*';
	$disc	= "ōǗҌBSĂ̏sł܂B";
	$alist	= '*';
	
	$pGRP->{'Administrators'} = "$range<>$disc<>$alist";
}

#============================================================================================================
#	W[I[
#============================================================================================================
1;
